
//MAX7456
#include "main.h"
#define baudrate 4800
#define cpuclock 16000000
#define SYSCLK	16000000
#define BAUD_RATE 4800
//FUNKTIONEN
void waitms(unsigned short int ms);
unsigned char read_SPI(void);
unsigned char Write_SPI(char data);
int uart_putchar (char c);
void DelayUs(unsigned int N);
void spiWriteCM();                                    // On entry: global data[1..960] contains char+attr bytes
volatile unsigned char data[DATA_BUF_LENGTH];



// RS232 INIT UART0
void init_rs232(unsigned int baud0,unsigned int baud1)
{

UCSR0B= ((1<<RXCIE0)|(1<<RXEN0) | (1<<TXEN0));
UBRR0L=(SYSCLK / (BAUD_RATE * 16L) - 1);


  }
  

 //zum Senden ber die UART 1
void send_UART(char *s)
{
uint8_t cz=0;
 while (*s)
    {   /* so lange *s != '\0' also ungleich dem "String-Endezeichen" */
if(cz>40)break;    
  loop_until_bit_is_set(UCSR0A, UDRE0);
 UDR0=(*s);
        s++;
		cz++;
    }
}


//SETZTE PORTS
void set_ports(void)
{
port_spi_osd_cs(); //CS OSD
port_spi_sck(); //SCK
port_spi_mosi();//MOSI
port_spi_miso();//MISO
port_spi_ss();//SS MASTER MODE


osd_cs_high();//CS High
ss_high();//SS High Master Mode

led1_port();
led2_port();
led3_port();


led1_low();
led2_low();
led3_low();

video_loss();
taster_set();
taster_set_pullup();
taster_move();
taster_move_pullup();
max_reset();	

}





int main(void)
{
set_ports();
waitms(500);
//RESET OSD
maxreset_low();
waitms(50);
maxreset_high();
osd_rest_chip();

int baud;
baud=cpuclock/((baudrate*16L)-1);
cli();
init_rs232(baud,baud);
sei();
waitms(500);
send_UART("----------------------\r\n");
send_UART("--   OSD-TERMINAL   --\r\n");
send_UART("----------------------\r\n");
send_UART("\r\n");
send_UART("System Test!\r\n");
send_UART("\r\n");
send_UART("Check LED1\r\n");
waitms(1000);
led1_high();
waitms(4000);
send_UART("Check LED2\r\n");
waitms(1000);
led2_high();
waitms(4000);
send_UART("Check LED3\r\n");
waitms(1000);
led3_high();
waitms(8000);
led1_low();
led2_low();
led3_low();
send_UART("SET POWER LED ON LED1\r\n");
waitms(1000);
led1_high();
waitms(1000);
send_UART("SET OSD ON/OFF LED ON LED2\r\n");
waitms(1000);
send_UART("SET VIDEO_LOSS LED ON LED3\r\n");
clear_osd();
spiWriteReg(0x04,0x04);
unsigned int x;
 for (x = 0; x < MAX_screen_rows; x++)
  {
   spiWriteReg(x + 0x10,WHITE_level_100);
    
  }
  
//clear_osd();
spiWriteReg(VIDEO_MODE_0_WRITE,0x4c);//48
spiWriteReg(VIDEO_MODE_1_WRITE,0x5f);//0x4
osd_offset_hor(0x29);
osd_offset_vert(0x10);

OSD_write_to_screen("<OSD Vers 1.0>", 6, 3,0,0);
//OSD_write_to_screen("Herrmann Andreas", 3, 4,1,1);

  








sprintf(buffer,"Status: %d\r\n",read_status_osd());
send_UART(&buffer[0]);
//AKKU ANZEIGE
OSD_write_to_screen("AKKU", 19, 0,0,0);
OSD_AKKU(5, 23, 0,1,0);
//hauptschleife

while(1)
{

//PRFE VIDEO LOSS
if ( PINB & (1<<PINB1) ) 
{
led3_high();//VIDEO SIGNAL VERLOREN
OSD_write_to_screen("-NO VIDEO SIGNAL-", 5, 14,1,0);
}
else
{
OSD_write_to_screen("                ", 5, 14,1,0);

led3_low();//VIDEO SIGNAL IST OK
}

//PRFE Taster SET 
if (PINC & (1<<PINC6) ) 
{
led2_low();
OSD_write_to_screen("        ", 0, 1,0,1);

}
else
{
led2_high();
OSD_write_to_screen("SET KEY", 0, 1,0,1);

//TASTER GEDRCKT
}

//PRFE Taster MOVE
if (PINC & (1<<PINC5) ) 
{
OSD_write_to_screen("          ", 0, 2,0,1);
led2_low();
}
else
{
led2_high();//TASTER GEDRCKT
OSD_write_to_screen("MOVE KEY", 0, 2,0,1);
}

}

}





//SPI READ
unsigned char read_SPI(void)
{
while(!(SPSR & (1<<SPIF)));
return (SPDR);
}
//SPI WRITE
unsigned char Write_SPI(char data)
{SPDR=data;
while(!(SPSR & (1<<SPIF)));

return SPDR;
}

//WARTE X MS 
void waitms(unsigned short int ms )
 {
  int i;
  for (i=0;i<ms;i++) _delay_ms(1);
}

void DelayUs(unsigned int N)
{
	unsigned int x;

	for(x=0; x<=N;x++);
}
